%% Scripts for lecture 3 - Classification
% Foundations of Intelligent Systems, 
% Marco Cuturi / Kyoto University
% 


%% Regression does not always work when regressing binary variables.

rand('state',0);
minX=-10;
maxX=50;
N=20;
% sample points between minX,maxX
% above pi
X=pi+(maxX-pi)*rand(N/2,1);
% below
X=[X;minX+(pi-minX)*rand(N/2,1)];
% assign label vector
Y=.5*(1+sign(X-pi));

% plot everything
figure(1);
clf
hold on;
scatter(X,Y,80,'bo');
axis([minX,maxX, -.1,1.1]);
pause;
h=ezplot('.5*(1+sign(x-pi))',[minX,maxX]);
set(h,'Color','blue')
set(h,'LineWidth',3)

vline(pi,'b--','\pi');

axis([minX,maxX, -.1,1.1]);
pause;
hold off


% plot points again
clf;
figure(1);
hold on;
scatter(X,Y,80,'bo');
axis([minX,maxX, -.1,1.1]);
pause;

% prepare regression by adding linear coefficient
XX=[ones(size(X)),X];
% use hat matrix
alpha=(XX'*XX)\XX'*Y;
% plot result of linear regression
estlinear= @(x) alpha(2)*x+alpha(1);
h=ezplot(estlinear,[minX,maxX]);
set(h,'Color','red')
set(h,'LineWidth',3)


axis([minX,maxX, -.1,1.1]);
pause;


h=ezplot('.5*(1+sign(x-pi))',[minX,maxX]);
set(h,'Color','blue')
set(h,'LineWidth',3)

vline(pi,'b--','\pi');
hline(0.5,'r-');
vline((.5-alpha(1))/alpha(2),'r--','f');
pause;

%% Plot the logistic map
clf;
ezplot('1/(exp(-x)+1)',[-4,4])
vline(0,'r-');
hline(1,'r--');
hline(0,'r--');
hline(0.5,'r-');
pause;

%% Plot now logistic regression

T=logistic(XX,Y)
estlinearlogistic= @(x) T(2)*x+T(1);
logistreg= ['1/(exp(-(',num2str(T(2)),'*x+(',num2str(T(1)),')))+1)'];

clf;
clf;
figure(1);
hold on;
scatter(X,Y,80,'bo');
axis([minX,maxX, -.1,1.1]);
pause;

h=ezplot(logistreg,[minX,maxX]);
set(h,'Color','red');
set(h,'LineWidth',3);

vline(pi,'r-');
hline(1,'r--');
hline(0,'r--');
hline(0.5,'r-');









